#include "falcon.h"
/*
    Text attributes
       0    All attributes off
       1    Bold on
       4    Underscore (on monochrome display adapter only)
       5    Blink on
       7    Reverse video on
       8    Concealed on

    Foreground colors
       30    Black
       31    Red
       32    Green
       33    Yellow
       34    Blue
       35    Magenta
       36    Cyan
       37    White

    Background colors
       40    Black
       41    Red
       42    Green
       43    Yellow
       44    Blue
       45    Magenta
       46    Cyan
       47    White

*/
#define BOLD_CHAR		2
#define REVERSE_CHAR	22
#define UNDERLINE_CHAR	32
#define RESET_CHAR		15
#define COLOR_CHAR		3
#define ANSI_CHAR		27

int Cmdfix_colors(void *cd,void *interp,int argc,char *argv[]) {
{
    Tcl_DString result;
	char c, *p, *old;
	int bold=0, reverse=0, underline=0, color=0, dlen, done = 0;
	char ansistring[10], *ansistart;
	int ansistringpos = 0;

	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: fix_colors <String> <Default Color>; returns: a string with the proper color codes.",NULL);
		return TCL_ERROR;
	}

    Tcl_DStringInit(&result);

	old = p = argv[1];
	dlen = strlen(argv[2]);
	while(*p != 0)
	{
		switch(*p)
		{
			case BOLD_CHAR:
				bold = 1 - bold;
				break;
			case REVERSE_CHAR:
				reverse = 1 - reverse;
				break;
			case UNDERLINE_CHAR:
				underline = 1 - underline;
				break;
			case RESET_CHAR:				
					p++;
					Tcl_DStringAppend(&result, p, p-old);
					Tcl_DStringAppend(&result, argv[2], dlen);
					old = p;
				break;
			case COLOR_CHAR:
				color = 1;
				break;
			case ANSI_CHAR:
				if(p != old)
				{
					Tcl_DStringAppend(&result, old, p-old);
				}
				ansistart = p;
				ansibak[0] = (char)ANSI_CHAR;
				ansibak[1] = '\0';
				p++;
				if(*p == '[')
				{
					strcat(ansibak, "[");
					while(!done)
					{
						ansistring[0] = '\0';
							ansistringpos = 0;
						p++;
						while(*p != 'm' && *p != ';' && ansistringpos < 3)
						{
							ansistring[ansistringpos] = *p;
							ansistringpos++;
							p++;
							ansistring[ansistringpos] = '\0';
						}
						if(*p == 'm')
							done = 1;
					}
				}
				else
				{
					p--;
				}
				break;
			default:
				Tcl_DStringAppend(&result, p, 1);
				break;
		}
		p++;
	}

    Tcl_DStringAppend(&result, &c, 1);

    Tcl_DStringResult(interp, &result);
	return TCL_OK;

}
