#ifndef IAL_H
#define IAL_H

struct ial_chanstruct
{
	char *channel;
	struct ial_chanstruct *next;
};
typedef struct ial_chanstruct *IAL_CHAN;

struct ial_struct
{
	char *nick;
	char *userhost;
	IAL_CHAN channels;
	struct ial_struct *next;
};
typedef struct ial_struct *IAL;

struct ial_headstruct
{
	void *interp;
	IAL ial;
	struct ial_headstruct *next;
};
typedef struct ial_headstruct *IAL_HEAD;

IAL_HEAD	find_ial_interp					(void *);
IAL			find_ial_user					(IAL_HEAD, char *);
IAL_HEAD	add_ial_interp					(void *);
IAL_CHAN	find_user_channel				(IAL, char *);
char		*ial_address					(void *, char *);
int			add_to_ial						(void *, char *, char *, char *);
int			remove_channel_from_ial			(void *, char *);
int			remove_channel_from_ial_nick	(void *, char *, char *);
int			change_ial_nick					(void *, char *, char *);
int			clear_ial						(void *);
int			delete_ial_user					(void *, char *);
int			delete_ial_interp				(void *);
int			ial_ison						(void *, char *, char *);
void		ial_nicks						(void *);
char		*ial_userhost					(void *, char *);
void		ial_userchannels				(void *, char *);

#endif /* IAL_H */
