#include <stdlib.h>
#include <string.h>

#define WEEK   604800
#define DAY    86400
#define HOUR   3600
#define MINUTE 60

char idlestr[256];

char	*get_token(char **src, char *token_sep)
/*
 * Just a little more convenient than strtok()
 * This function returns a pointer to the first token
 * in src, and makes src point to the "new string".
 *
 */
{
	char	*tok;

	if(!(src && *src && **src))
		return NULL;

	/* first, removes leading token_sep's */
	while(**src && strchr(token_sep, **src))
		(*src)++;
	
	/* first non token_sep */
	if(**src)
		tok = *src;
	else
		return NULL;

	/* Make *src point after token */
	*src = strpbrk(*src, token_sep);
	if(*src)
	{
		**src = '\0';
		(*src)++;
		while(**src && strchr(token_sep, **src))
			(*src)++;
	}
	else
		*src = "";
	return tok;
}

char *EXTRA_CHAR(int num)
{
	if(num == 1)
		return "";
	else
		return "s";
}

char	*idle2str(long t)
{
	int	weeks, days, hours, mins, secs;
	
	weeks = t/WEEK;		t -= weeks * WEEK;
	days  = t/DAY;		t -= days  * DAY;
	hours = t/HOUR;		t -= hours * HOUR;
	mins  = t/MINUTE;	t -= mins  * MINUTE;
	secs  = t;

	if(weeks)
		sprintf(idlestr, "%d week%s, %d day%s, %d hour%s, %d minute%s and %d second%s",
			weeks, EXTRA_CHAR(weeks), days, EXTRA_CHAR(days),
			hours, EXTRA_CHAR(hours), mins, EXTRA_CHAR(mins),
			secs, EXTRA_CHAR(secs));
	else if(days)
		sprintf(idlestr, "%d day%s, %d hour%s, %d minute%s and %d second%s",
			days, EXTRA_CHAR(days), hours, EXTRA_CHAR(hours),
			mins, EXTRA_CHAR(mins), secs, EXTRA_CHAR(secs));
	else if(hours)
		sprintf(idlestr, "hour%s, %d minute%s and %d second%s",
			hours, EXTRA_CHAR(hours), mins, EXTRA_CHAR(mins),
			secs, EXTRA_CHAR(secs));
	else if(mins)
		sprintf(idlestr, "%d minute%s and %d second%s",
			mins, EXTRA_CHAR(mins), secs, EXTRA_CHAR(secs));
	else
		sprintf(idlestr, "%d second%s",
			secs, EXTRA_CHAR(secs));
	return idlestr;
}

